var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
define(["require", "exports", "commands/commandBase"], function(require, exports, commandBase) {
    var createDatabaseCommand = (function (_super) {
        __extends(createDatabaseCommand, _super);
        function createDatabaseCommand(databaseName, settings, securedSettings) {
            _super.call(this);
            this.databaseName = databaseName;
            this.settings = settings;
            this.securedSettings = securedSettings;

            if (!databaseName) {
                this.reportError("Database must have a name!");
                throw new Error("Database must have a name!");
            }
        }
        createDatabaseCommand.prototype.execute = function () {
            var _this = this;
            this.reportInfo("Creating " + this.databaseName);
            var databaseDoc = {
                "Settings": this.settings,
                "SecuredSettings": this.securedSettings,
                "Disabled": false
            };

            var url = "/admin/databases/" + this.databaseName;
            var createTask = this.put(url, JSON.stringify(databaseDoc), null, { dataType: undefined });
            createTask.done(function () {
                return _this.reportSuccess(_this.databaseName + " created");
            });
            createTask.fail(function (response) {
                return _this.reportError("Failed to create database", response.responseText, response.statusText);
            });

            createTask.done(function () {
                return _this.query("/databases/" + _this.databaseName + "/silverlight/ensureStartup", null, null);
            });

            return createTask;
        };
        return createDatabaseCommand;
    })(commandBase);

    
    return createDatabaseCommand;
});
