var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
define(["require", "exports", "commands/commandBase"], function(require, exports, commandBase) {
    var deleteDatabaseCommand = (function (_super) {
        __extends(deleteDatabaseCommand, _super);
        function deleteDatabaseCommand(databaseName, isHardDelete, systemDb) {
            _super.call(this);
            this.databaseName = databaseName;
            this.isHardDelete = isHardDelete;
            this.systemDb = systemDb;
        }
        deleteDatabaseCommand.prototype.execute = function () {
            var _this = this;
            this.reportInfo("Deleting " + this.databaseName + "...");

            var url = "/admin/databases/" + encodeURIComponent(this.databaseName) + "?hard-delete=" + this.isHardDelete;
            var deleteTask = this.del(url, null, this.systemDb, { dataType: undefined });
            deleteTask.fail(function (response) {
                return _this.reportError("Failed to delete database", response.responseText, response.statusText);
            });
            deleteTask.done(function () {
                return _this.reportSuccess("Deleted " + _this.databaseName);
            });
            return deleteTask;
        };
        return deleteDatabaseCommand;
    })(commandBase);

    
    return deleteDatabaseCommand;
});
