var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
define(["require", "exports", "commands/executeBulkDocsCommand"], function(require, exports, executeBulkDocsCommand) {
    var deleteDocumentsCommand = (function (_super) {
        __extends(deleteDocumentsCommand, _super);
        function deleteDocumentsCommand(docIds, db) {
            var bulkDocs = docIds.map(function (id) {
                return deleteDocumentsCommand.createDeleteDocument(id);
            });
            _super.call(this, bulkDocs, db);
        }
        deleteDocumentsCommand.prototype.execute = function () {
            var _this = this;
            var docCount = this.docs.length;
            var alertInfoTitle = docCount === 1 ? "Deleting " + this.docs[0].Key : "Deleting " + docCount + " docs...";
            this.reportInfo(alertInfoTitle);

            var deleteTask = _super.prototype.execute.call(this);

            deleteTask.done(function () {
                return _this.reportSuccess("Deleted " + docCount + " docs");
            });
            deleteTask.fail(function (response) {
                return _this.reportError("Failed to delete docs", response.responseText, response.statusText);
            });

            return deleteTask;
        };

        deleteDocumentsCommand.createDeleteDocument = function (id) {
            return {
                Key: id,
                Method: "DELETE",
                Etag: null,
                AdditionalData: null
            };
        };
        return deleteDocumentsCommand;
    })(executeBulkDocsCommand);

    
    return deleteDocumentsCommand;
});
