﻿var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
define(["require", "exports", "commands/commandBase"], function(require, exports, commandBase) {
    var getFilesystemDestinationsCommand = (function (_super) {
        __extends(getFilesystemDestinationsCommand, _super);
        function getFilesystemDestinationsCommand(fs) {
            _super.call(this);
            this.fs = fs;
        }
        getFilesystemDestinationsCommand.prototype.execute = function () {
            var url = "/config";
            var args = {
                name: "Raven/Synchronization/Destinations"
            };

            var task = $.Deferred();
            this.query(url, args, this.fs).done(function (data) {
                if (data.hasOwnProperty('destination')) {
                    var value = data['destination'];
                    if (!(value instanceof Array))
                        value = [value];

                    var result = value.map(function (x) {
                        return JSON.parse(x);
                    });
                    task.resolve(result);
                } else {
                    task.resolve([]);
                }
            });

            return task;
        };
        return getFilesystemDestinationsCommand;
    })(commandBase);

    
    return getFilesystemDestinationsCommand;
});
