﻿var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
define(["require", "exports", "commands/commandBase"], function(require, exports, commandBase) {
    var saveFilesystemConfigurationCommand = (function (_super) {
        __extends(saveFilesystemConfigurationCommand, _super);
        function saveFilesystemConfigurationCommand(fs, destination) {
            _super.call(this);
            this.fs = fs;
            this.destination = destination;
        }
        saveFilesystemConfigurationCommand.prototype.execute = function () {
            var _this = this;
            var result = $.Deferred();

            var dtos = [];

            this.query("/config", { name: "Raven/Synchronization/Destinations" }, this.fs).done(function (data) {
                dtos = dtos.concat(_this.destination);
                if (data && data.hasOwnProperty('destination')) {
                    var value = data['destination'];
                    if (!(value instanceof Array))
                        value = [value];

                    dtos = dtos.concat(value.map(function (x) {
                        return JSON.parse(x);
                    }));
                }
            }).always(function (x) {
                var url = "/config?name=" + encodeURIComponent("Raven/Synchronization/Destinations");

                var doc = {
                    destination: dtos.map(function (x) {
                        return JSON.stringify(x);
                    })
                };

                var docAsString = JSON.stringify(doc);

                _this.put(url, docAsString, _this.fs).done(function (y) {
                    result.resolve(dtos);
                });
            });

            return result;
        };
        return saveFilesystemConfigurationCommand;
    })(commandBase);

    
    return saveFilesystemConfigurationCommand;
});
