﻿var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
define(["require", "exports", "commands/commandBase"], function(require, exports, commandBase) {
    var updateFileMetadataCommand = (function (_super) {
        __extends(updateFileMetadataCommand, _super);
        function updateFileMetadataCommand(fileName, metadata, fs, reportSaveProgress) {
            if (typeof reportSaveProgress === "undefined") { reportSaveProgress = true; }
            _super.call(this);
            this.fileName = fileName;
            this.metadata = metadata;
            this.fs = fs;
            this.reportSaveProgress = reportSaveProgress;
        }
        updateFileMetadataCommand.prototype.execute = function () {
            var _this = this;
            if (this.reportSaveProgress) {
                this.reportInfo("Saving " + this.fileName + "...");
            }

            var customHeaders = {};

            for (var key in this.metadata) {
                customHeaders[key] = JSON.stringify(this.metadata[key]);
            }

            var jQueryOptions = {
                headers: customHeaders
            };

            var url = "/files/" + this.fileName;
            var updateTask = this.post(url, null, this.fs, jQueryOptions);

            if (this.reportSaveProgress) {
                updateTask.done(function () {
                    return _this.reportSuccess("Saved " + _this.fileName);
                });
                updateTask.fail(function (response) {
                    _this.reportError("Failed to save " + _this.fileName, response.responseText, response.statusText);
                });
            }

            return updateTask;
        };
        return updateFileMetadataCommand;
    })(commandBase);

    
    return updateFileMetadataCommand;
});
