var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
define(["require", "exports", "commands/commandBase"], function(require, exports, commandBase) {
    var saveAutomaticConflictResolutionDocument = (function (_super) {
        __extends(saveAutomaticConflictResolutionDocument, _super);
        function saveAutomaticConflictResolutionDocument(dto, db) {
            _super.call(this);
            this.dto = dto;
            this.db = db;
        }
        saveAutomaticConflictResolutionDocument.prototype.execute = function () {
            var _this = this;
            this.reportInfo("Saving automatic conflict resolution settings.");
            return this.saveConfig().done(function () {
                return _this.reportSuccess("Saved automatic conflict resolution settings.");
            }).fail(function (response) {
                return _this.reportError("Failed to save automatic conflict resolution settings.", response.responseText);
            });
        };

        saveAutomaticConflictResolutionDocument.prototype.saveConfig = function () {
            var id = "Raven/Replication/Config";
            var url = "/docs/" + id;
            var putArgs = JSON.stringify(this.dto);
            return this.put(url, putArgs, this.db);
        };
        return saveAutomaticConflictResolutionDocument;
    })(commandBase);

    
    return saveAutomaticConflictResolutionDocument;
});
