var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
define(["require", "exports", "commands/deleteDocumentCommand", "commands/commandBase", "commands/getDocumentWithMetadataCommand"], function(require, exports, deleteDocumentCommand, commandBase, getDocumentWithMetadataCommand) {
    var startRestoreCommand = (function (_super) {
        __extends(startRestoreCommand, _super);
        function startRestoreCommand(db, defrag, restoreRequest, updateRestoreStatus) {
            _super.call(this);
            this.db = db;
            this.defrag = defrag;
            this.restoreRequest = restoreRequest;
            this.updateRestoreStatus = updateRestoreStatus;
        }
        startRestoreCommand.prototype.execute = function () {
            var _this = this;
            var result = $.Deferred();

            new deleteDocumentCommand('Raven/Restore/Status', this.db).execute().fail(function (response) {
                return result.reject(response);
            }).done(function (_) {
                _this.post('/admin/restore?defrag=' + _this.defrag, ko.toJSON(_this.restoreRequest), _this.db, { dataType: 'text' }).fail(function (response) {
                    var r = JSON.parse(response.responseText);
                    var restoreStatus = { Messages: [r.Error], IsRunning: false };
                    _this.updateRestoreStatus(restoreStatus);
                    result.reject(response);
                }).done(function (response) {
                    _this.getRestoreStatus(result);
                });
            });

            return result;
        };

        startRestoreCommand.prototype.getRestoreStatus = function (result) {
            var _this = this;
            new getDocumentWithMetadataCommand("Raven/Restore/Status", this.db).execute().fail(function (response) {
                return result.reject(response);
            }).done(function (restoreStatus) {
                var lastMessage = restoreStatus.Messages.last();
                var isRestoreFinished = lastMessage.contains("The new database was created") || lastMessage.contains("Restore Canceled") || lastMessage.contains("A database name must be supplied if the restore location does not contain a valid Database.Document file") || lastMessage.contains("Cannot do an online restore for the <system> database") || lastMessage.contains("Restore ended but could not create the datebase document, in order to access the data create a database with the appropriate name");

                restoreStatus.IsRunning = !isRestoreFinished;
                _this.updateRestoreStatus(restoreStatus);

                if (!isRestoreFinished) {
                    setTimeout(function () {
                        return _this.getRestoreStatus(result);
                    }, 1000);
                }
            });
        };
        return startRestoreCommand;
    })(commandBase);

    
    return startRestoreCommand;
});
