﻿define(["require", "exports", "models/filesystem/synchronizationDetail", "models/filesystem/synchronizationReport"], function(require, exports, synchronizationDetail, synchronizationReport) {
    var synchronizationDetails = (function () {
        function synchronizationDetails() {
            this.pending = [];
            this.active = [];
            this.finished = [];
        }
        synchronizationDetails.fromOutgoingActivities = function (pending, active) {
            var details = new synchronizationDetails();

            if (active != null) {
                details.active.pushAll(active.map(function (x) {
                    return new synchronizationDetail(x);
                }));
            }

            if (pending != null) {
                details.pending.pushAll(pending.map(function (x) {
                    return new synchronizationDetail(x);
                }));
            }

            return details;
        };

        synchronizationDetails.fromIncomingActivities = function (finished) {
            var details = new synchronizationDetails();
            if (finished != null) {
                details.finished.pushAll(finished.map(function (x) {
                    return new synchronizationReport(x);
                }));
            }
            return details;
        };
        return synchronizationDetails;
    })();

    
    return synchronizationDetails;
});
