var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
define(["require", "exports", "models/document"], function(require, exports, document) {
    var scriptedIndex = (function (_super) {
        __extends(scriptedIndex, _super);
        function scriptedIndex(dto) {
            _super.call(this, dto);
            this.deleteLater = ko.observable();
            this.indexScript = ko.observable();
            this.deleteScript = ko.observable();

            this.indexScript(dto.IndexScript);
            this.deleteScript(dto.DeleteScript);
        }
        scriptedIndex.emptyForIndex = function (indexName) {
            var meta = [];
            meta['@id'] = "Raven/ScriptedIndexResults/" + indexName;
            meta['Raven-Entity-Name'] = 'ScriptedIndexResults';
            return new scriptedIndex({
                '@metadata': meta,
                IndexScript: "",
                DeleteScript: ""
            });
        };

        scriptedIndex.prototype.toDto = function () {
            var meta = this.__metadata.toDto();
            return {
                '@metadata': meta,
                IndexScript: this.indexScript(),
                DeleteScript: this.deleteScript()
            };
        };

        scriptedIndex.prototype.markToDelete = function () {
            this.indexScript("");
            this.deleteScript("");
            this.deleteLater(true);
        };

        scriptedIndex.prototype.cancelDeletion = function () {
            this.deleteLater(false);
        };

        scriptedIndex.prototype.isMarkedToDelete = function () {
            return this.deleteLater();
        };
        return scriptedIndex;
    })(document);

    
    return scriptedIndex;
});
