define(["require", "exports"], function(require, exports) {
    var sqlReplicationTable = (function () {
        function sqlReplicationTable(dto) {
            this.tableName = ko.observable().extend({ required: true });
            this.documentKeyColumn = ko.observable().extend({ required: true });
            this.tableName(dto.TableName);
            this.documentKeyColumn(dto.DocumentKeyColumn);
        }
        sqlReplicationTable.empty = function () {
            return new sqlReplicationTable({
                TableName: null,
                DocumentKeyColumn: null
            });
        };

        sqlReplicationTable.prototype.toDto = function () {
            return {
                TableName: this.tableName(),
                DocumentKeyColumn: this.documentKeyColumn()
            };
        };

        sqlReplicationTable.prototype.isValid = function () {
            var requiredValues = [this.tableName(), this.documentKeyColumn()];
            return requiredValues.every(function (v) {
                return v != null && v.length > 0;
            });
        };
        return sqlReplicationTable;
    })();

    
    return sqlReplicationTable;
});
