﻿define(["require", "exports", "models/databaseAccess"], function(require, exports, databaseAccess) {
    var windowsAuthData = (function () {
        function windowsAuthData(dto) {
            this.name = ko.observable();
            this.enabled = ko.observable();
            this.databases = ko.observableArray();
            this.name(dto.Name);
            this.enabled(dto.Enabled);
            this.databases(dto.Databases.map(function (dbDto) {
                return new databaseAccess(dbDto);
            }));
        }
        windowsAuthData.prototype.toDto = function () {
            return {
                Name: this.name(),
                Enabled: this.enabled(),
                Databases: this.databases().map(function (db) {
                    return db.toDto();
                })
            };
        };

        windowsAuthData.empty = function () {
            return new windowsAuthData({
                Name: "[new settings]",
                Enabled: false,
                Databases: []
            });
        };

        windowsAuthData.prototype.enable = function () {
            this.enabled(true);
        };

        windowsAuthData.prototype.disable = function () {
            this.enabled(false);
        };

        windowsAuthData.prototype.addDatabase = function () {
            this.databases.push(databaseAccess.empty());
        };

        windowsAuthData.prototype.removeDatabase = function (dba) {
            this.databases.remove(dba);
        };
        return windowsAuthData;
    })();
    
    return windowsAuthData;
});
