﻿define(["require", "exports", "models/windowsAuthData"], function(require, exports, windowsAuthData) {
    var windowsAuthSetup = (function () {
        function windowsAuthSetup(dto) {
            this.requiredGroups = ko.observableArray();
            this.requiredUsers = ko.observableArray();
            this.requiredGroups(dto.RequiredGroups.map(function (winAuthDto) {
                return new windowsAuthData(winAuthDto);
            }));
            this.requiredUsers(dto.RequiredUsers.map(function (winAuthDto) {
                return new windowsAuthData(winAuthDto);
            }));
        }
        windowsAuthSetup.prototype.toDto = function () {
            return {
                RequiredGroups: this.requiredGroups().map(function (grp) {
                    return grp.toDto();
                }),
                RequiredUsers: this.requiredUsers().map(function (usr) {
                    return usr.toDto();
                })
            };
        };
        return windowsAuthSetup;
    })();
    
    return windowsAuthSetup;
});
