﻿var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
define(["require", "exports", "commands/deleteTransformerCommand", "plugins/dialog", "viewmodels/dialogViewModelBase"], function(require, exports, deleteTransformerCommand, dialog, dialogViewModelBase) {
    var deleteTransformerConfirm = (function (_super) {
        __extends(deleteTransformerConfirm, _super);
        function deleteTransformerConfirm(transformersNames, db) {
            _super.call(this);
            this.transformersNames = transformersNames;
            this.db = db;
            this.deleteTask = $.Deferred();

            if (!transformersNames || transformersNames.length === 0) {
                throw new Error("Transformers must not be null or empty.");
            }
        }
        deleteTransformerConfirm.prototype.deleteTransformers = function () {
            var _this = this;
            var deleteTasks = this.transformersNames.map(function (name) {
                return new deleteTransformerCommand(name, _this.db).execute();
            });

            $.when(deleteTasks).done(function () {
                return _this.deleteTask.resolve();
            });
            dialog.close(this);
        };

        deleteTransformerConfirm.prototype.cancel = function () {
            this.deleteTask.reject();
            dialog.close(this);
        };
        return deleteTransformerConfirm;
    })(dialogViewModelBase);

    
    return deleteTransformerConfirm;
});
