﻿var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
define(["require", "exports", "viewmodels/viewModelBase", "commands/filesystem/getFilesystemStatsCommand"], function(require, exports, viewModelBase, getFilesystemStatsCommand) {
    var filesystemStatistics = (function (_super) {
        __extends(filesystemStatistics, _super);
        function filesystemStatistics() {
            _super.apply(this, arguments);
            this.stats = ko.observable();
        }
        filesystemStatistics.prototype.fetchStats = function () {
            var _this = this;
            var db = this.activeFilesystem();
            if (db) {
                return new getFilesystemStatsCommand(db).execute().done(function (result) {
                    return _this.processStatsResults(result);
                });
            }

            return null;
        };

        filesystemStatistics.prototype.modelPolling = function () {
            this.fetchStats();
        };

        filesystemStatistics.prototype.processStatsResults = function (results) {
            if (filesystemStatistics != null) {
                this.stats(results);
            }
        };
        return filesystemStatistics;
    })(viewModelBase);

    
    return filesystemStatistics;
});
