﻿var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
define(["require", "exports", "durandal/system", "plugins/router", "common/appUrl", "commands/filesystem/uploadFileToFilesystemCommand", "models/uploadItem", "viewmodels/viewModelBase"], function(require, exports, system, router, appUrl, uploadFileToFilesystemCommand, uploadItem, viewModelBase) {
    var filesystemUploadFile = (function (_super) {
        __extends(filesystemUploadFile, _super);
        function filesystemUploadFile() {
            var _this = this;
            _super.call(this);
            this.files = ko.observable();
            this.uploadQueue = ko.observableArray();

            this.uploadQueue.subscribe(function (x) {
                return _this.updateLocalStorage(x, _this.activeFilesystem());
            });

            ko.bindingHandlers["fileUpload"] = {
                init: function (element, valueAccessor) {
                },
                update: function (element, valueAccessor, allBindingsAccessor, viewModel, bindingContext) {
                    var options = ko.utils.unwrapObservable(valueAccessor());
                    var context = viewModel;
                    var filesystem = ko.utils.unwrapObservable(bindingContext.$data["activeFilesystem"]);

                    if (options) {
                        if (element.files.length) {
                            var files = element.files;
                            for (var i = 0; i < files.length; i++) {
                                var file = files[i];
                                var guid = system.guid();
                                var item = new uploadItem(guid, file.name, "Queued", context.activeFilesystem());
                                context.uploadQueue.push(item);

                                new uploadFileToFilesystemCommand(file, guid, filesystem, function (event) {
                                    if (event.lengthComputable) {
                                        var percentComplete = event.loaded / event.total;
                                    }
                                }, true).execute().done(function (x) {
                                    ko.postbox.publish("UploadFileStatusChanged", x);
                                    context.updateQueueStatus(x.id(), "Uploaded", context.uploadQueue());
                                }).fail(function (x) {
                                    ko.postbox.publish("UploadFileStatusChanged", x);
                                    context.updateQueueStatus(x.id(), "Failed", context.uploadQueue());
                                });

                                item.status("Uploading...");
                                context.uploadQueue.notifySubscribers(context.uploadQueue());
                            }
                        }

                        context.files(null);
                    }
                }
            };
        }
        filesystemUploadFile.prototype.activate = function (navigationArgs) {
            _super.prototype.activate.call(this, navigationArgs);

            var storageKeyForFs = this.localStorageUploadQueueKey + this.activeFilesystem().name;
            if (window.localStorage.getItem(storageKeyForFs)) {
                this.uploadQueue(this.parseUploadQueue(window.localStorage.getItem(storageKeyForFs), this.activeFilesystem()));
            }
        };

        filesystemUploadFile.prototype.clearUploadQueue = function () {
            window.localStorage.removeItem(this.localStorageUploadQueueKey + this.activeFilesystem().name);
            this.uploadQueue.removeAll();
        };

        filesystemUploadFile.prototype.navigateToFiles = function () {
            router.navigate(appUrl.forFilesystemFiles(this.activeFilesystem()));
        };
        return filesystemUploadFile;
    })(viewModelBase);

    
    return filesystemUploadFile;
});
