﻿var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
define(["require", "exports", "viewmodels/dialogViewModelBase", "plugins/dialog"], function(require, exports, dialogViewModelBase, dialog) {
    var searchFileSizeRangeClause = (function (_super) {
        __extends(searchFileSizeRangeClause, _super);
        function searchFileSizeRangeClause() {
            _super.apply(this, arguments);
            this.applyFilterTask = $.Deferred();
            this.minSizeText = ko.observable("");
            this.maxSizeText = ko.observable("");
        }
        searchFileSizeRangeClause.prototype.cancel = function () {
            dialog.close(this);
        };

        searchFileSizeRangeClause.prototype.applyFilter = function () {
            var filter = "__size_numeric:[" + this.convertInputStringToRangeValue(this.minSizeText()) + " TO " + this.convertInputStringToRangeValue(this.maxSizeText()) + "]";
            this.applyFilterTask.resolve(filter);
            dialog.close(this);
        };

        searchFileSizeRangeClause.prototype.convertInputStringToRangeValue = function (input) {
            if (!input)
                return "*";

            var regex = /^(\d+)\s*(\w*)$/;
            if (!regex.test(input))
                return "*";

            var match = regex.exec(input);
            var value = parseInt(match[1]);
            var multiplier = this.getMultiplier(match[2]);

            value *= multiplier;

            return value.toString();
        };

        searchFileSizeRangeClause.prototype.getMultiplier = function (value) {
            if (!value)
                return 1;

            if (value.indexOf("k") > -1)
                return 1024;

            if (value.indexOf("m") > -1)
                return 1024 * 1024;

            if (value.indexOf("g") > -1)
                return 1024 * 1024 * 1024;

            return 1;
        };
        return searchFileSizeRangeClause;
    })(dialogViewModelBase);

    
    return searchFileSizeRangeClause;
});
