var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
define(["require", "exports", "viewmodels/viewModelBase", "commands/getDatabaseStatsCommand", "moment"], function(require, exports, viewModelBase, getDatabaseStatsCommand, moment) {
    var indexErrors = (function (_super) {
        __extends(indexErrors, _super);
        function indexErrors() {
            _super.call(this);
            this.allIndexErrors = ko.observableArray();
            this.hasFetchedErrors = ko.observable(false);
            this.selectedIndexError = ko.observable();
            this.now = ko.observable();
            this.updateNowTimeoutHandle = 0;

            this.updateCurrentNowTime();
        }
        indexErrors.prototype.modelPolling = function () {
            return this.fetchIndexErrors();
        };

        indexErrors.prototype.deactivate = function () {
            clearTimeout(this.updateNowTimeoutHandle);
        };

        indexErrors.prototype.fetchIndexErrors = function () {
            var _this = this;
            var db = this.activeDatabase();
            if (db) {
                return new getDatabaseStatsCommand(db).execute().done(function (stats) {
                    stats.Errors.forEach(function (e) {
                        return e['TimestampHumanized'] = _this.createHumanReadableTime(e.Timestamp);
                    });
                    _this.allIndexErrors(stats.Errors);
                    _this.hasFetchedErrors(true);
                });
            }

            return null;
        };

        indexErrors.prototype.tableKeyDown = function () {
        };

        indexErrors.prototype.selectIndexError = function (indexError) {
            this.selectedIndexError(indexError);
        };

        indexErrors.prototype.createHumanReadableTime = function (time) {
            var _this = this;
            if (time) {
                return ko.computed(function () {
                    var dateMoment = moment(time);
                    var agoInMs = dateMoment.diff(_this.now());
                    return moment.duration(agoInMs).humanize(true) + dateMoment.format(" (MM/DD/YY, h:mma)");
                });
            }

            return ko.computed(function () {
                return time;
            });
        };

        indexErrors.prototype.updateCurrentNowTime = function () {
            var _this = this;
            this.now(moment());
            this.updateNowTimeoutHandle = setTimeout(function () {
                return _this.updateCurrentNowTime();
            }, 60000);
        };
        return indexErrors;
    })(viewModelBase);

    
    return indexErrors;
});
