var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
define(["require", "exports", "viewmodels/viewModelBase", "commands/getIndexTermsCommand", "commands/getIndexDefinitionCommand"], function(require, exports, viewModelBase, getIndexTermsCommand, getIndexDefinitionCommand) {
    var indexTerms = (function (_super) {
        __extends(indexTerms, _super);
        function indexTerms() {
            _super.apply(this, arguments);
            this.fields = ko.observableArray();
        }
        indexTerms.prototype.activate = function (indexName) {
            _super.prototype.activate.call(this, indexName);

            this.fetchIndexDefinition(indexName);
        };

        indexTerms.prototype.fetchIndexDefinition = function (indexName) {
            var _this = this;
            new getIndexDefinitionCommand(indexName, this.activeDatabase()).execute().done(function (results) {
                return _this.processIndex(results);
            });
        };

        indexTerms.prototype.processIndex = function (indexContainer) {
            var _this = this;
            var fields = indexContainer.Index.Fields.map(function (fieldName) {
                return { name: fieldName, terms: ko.observableArray() };
            });
            this.fields(fields);

            this.fields().forEach(function (field) {
                new getIndexTermsCommand(indexContainer.Index.Name, field.name, _this.activeDatabase()).execute().done(function (terms) {
                    return field.terms(terms);
                });
            });
        };
        return indexTerms;
    })(viewModelBase);

    
    return indexTerms;
});
