var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
define(["require", "exports", "plugins/router", "viewmodels/viewModelBase", "common/appUrl"], function(require, exports, durandalRouter, viewModelBase, appUrl) {
    var indexesShell = (function (_super) {
        __extends(indexesShell, _super);
        function indexesShell() {
            var _this = this;
            _super.call(this);
            this.indexesUrl = appUrl.forCurrentDatabase().indexes;
            this.isIndexNameVisible = ko.observable(false);
            this.indexName = ko.observable();

            this.appUrls = appUrl.forCurrentDatabase();

            this.router = durandalRouter.createChildRouter().map([
                { route: 'databases/indexes', moduleId: 'viewmodels/indexes', title: 'Indexes', nav: true },
                { route: 'databases/indexes/edit(/:indexName)', moduleId: 'viewmodels/editIndex', title: 'Edit Index', nav: true },
                { route: 'databases/indexes/terms/(:indexName)', moduleId: 'viewmodels/indexTerms', title: 'Terms', nav: true }
            ]).buildNavigationModel();

            this.currentBreadcrumbTitle = ko.computed(function () {
                var activeRoute = _this.router.navigationModel().first(function (r) {
                    return r.isActive();
                });
                if (activeRoute && activeRoute.title === "Indexes") {
                    return "All";
                }

                return activeRoute != null ? activeRoute.title : "";
            });
        }
        indexesShell.prototype.activate = function (indexName) {
            if (indexName != null) {
                this.indexName(indexName);
                this.isIndexNameVisible(true);
            }
        };
        return indexesShell;
    })(viewModelBase);

    
    return indexesShell;
});
