﻿var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
define(["require", "exports", "commands/startRestoreCommand", "viewmodels/viewModelBase"], function(require, exports, startRestoreCommand, viewModelBase) {
    var restoreDatabase = (function (_super) {
        __extends(restoreDatabase, _super);
        function restoreDatabase() {
            _super.apply(this, arguments);
            this.defrag = ko.observable(false);
            this.backupLocation = ko.observable('C:\\path-to-your-backup-folder');
            this.databaseLocation = ko.observable();
            this.databaseName = ko.observable();
            this.restoreStatusMessages = ko.observableArray();
            this.isBusy = ko.observable();
        }
        restoreDatabase.prototype.startRestore = function () {
            var _this = this;
            var restoreDatabaseDto = {
                RestoreLocation: this.backupLocation(),
                DatabaseLocation: this.databaseLocation(),
                DatabaseName: this.databaseName()
            };
            var updateRestoreStatus = function (newRestoreStatus) {
                _this.restoreStatusMessages(newRestoreStatus.Messages);
                _this.isBusy(!!newRestoreStatus.IsRunning);
            };

            new startRestoreCommand(this.activeDatabase(), this.defrag(), restoreDatabaseDto, updateRestoreStatus).execute().always(function () {
                return _this.isBusy(false);
            });
        };
        return restoreDatabase;
    })(viewModelBase);

    
    return restoreDatabase;
});
