﻿var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
define(["require", "exports", "commands/saveTransformerCommand", "plugins/dialog", "viewmodels/dialogViewModelBase", "common/alertArgs", "common/alertType"], function(require, exports, saveTransformerCommand, dialog, dialogViewModelBase, alertArgs, alertType) {
    var saveTransformerWithNewNameConfirm = (function (_super) {
        __extends(saveTransformerWithNewNameConfirm, _super);
        function saveTransformerWithNewNameConfirm(savedTransformer, db) {
            _super.call(this);
            this.savedTransformer = savedTransformer;
            this.db = db;
            this.saveTask = $.Deferred();

            if (!savedTransformer) {
                throw new Error("Transformer must not be null");
            }

            this.message = "If you wish to save a new transformer with this new name press OK, to cancel the save command press Cancel";
        }
        saveTransformerWithNewNameConfirm.prototype.saveTransformer = function () {
            var _this = this;
            new saveTransformerCommand(this.savedTransformer, this.db).execute().done(function (trans) {
                return _this.saveTask.resolve(trans);
            });
            dialog.close(this);
        };

        saveTransformerWithNewNameConfirm.prototype.cancel = function () {
            this.saveTask.reject();
            ko.postbox.publish("Alert", new alertArgs(0 /* info */, "Transformer Not Saved"));
            dialog.close(this);
        };
        return saveTransformerWithNewNameConfirm;
    })(dialogViewModelBase);

    
    return saveTransformerWithNewNameConfirm;
});
