var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
define(["require", "exports", "plugins/router", "common/appUrl", "viewmodels/viewModelBase"], function(require, exports, durandalRouter, appUrl, viewModelBase) {
    var tasks = (function (_super) {
        __extends(tasks, _super);
        function tasks() {
            var _this = this;
            _super.call(this);
            this.router = null;

            this.isOnSystemDatabase = ko.computed(function () {
                return _this.activeDatabase() && _this.activeDatabase().isSystem;
            });
            this.isOnUserDatabase = ko.computed(function () {
                return _this.activeDatabase() && !_this.isOnSystemDatabase();
            });
            this.appUrls = appUrl.forCurrentDatabase();

            var importDatabaseUrl = ko.computed(function () {
                return appUrl.forImportDatabase(_this.activeDatabase());
            });
            var exportDatabaseUrl = ko.computed(function () {
                return appUrl.forExportDatabase(_this.activeDatabase());
            });
            var backupDatabaseUrl = ko.computed(function () {
                return appUrl.forBackupDatabase(_this.activeDatabase());
            });
            var restoreDatabaseUrl = ko.computed(function () {
                return appUrl.forRestoreDatabase(_this.activeDatabase());
            });
            var toggleIndexingUrl = ko.computed(function () {
                return appUrl.forToggleIndexing(_this.activeDatabase());
            });
            var sampleDataUrl = ko.computed(function () {
                return appUrl.forSampleData(_this.activeDatabase());
            });
            var csvImportUrl = ko.computed(function () {
                return appUrl.forCsvImport(_this.activeDatabase());
            });

            this.router = durandalRouter.createChildRouter().map([
                { route: ['databases/tasks', 'databases/tasks/importDatabase'], moduleId: 'viewmodels/importDatabase', title: 'Import Database', nav: true, hash: importDatabaseUrl },
                { route: 'databases/tasks/exportDatabase', moduleId: 'viewmodels/exportDatabase', title: 'Export Database', nav: true, hash: exportDatabaseUrl },
                { route: 'databases/tasks/backupDatabase', moduleId: 'viewmodels/backupDatabase', title: 'Backup Database', nav: true, hash: backupDatabaseUrl },
                { route: 'databases/tasks/restoreDatabase', moduleId: 'viewmodels/restoreDatabase', title: 'Restore Database', nav: true, hash: restoreDatabaseUrl },
                { route: 'databases/tasks/toggleIndexing', moduleId: 'viewmodels/toggleIndexing', title: 'Toggle Indexing', nav: true, hash: toggleIndexingUrl },
                { route: 'databases/tasks/sampleData', moduleId: 'viewmodels/createSampledata', title: 'Create Sample Data', nav: true, hash: sampleDataUrl },
                { route: 'databases/tasks/csvImport', moduleId: 'viewmodels/csvImport', title: 'CSV Import', nav: true, hash: csvImportUrl }
            ]).buildNavigationModel();

            this.activeSubViewTitle = ko.computed(function () {
                var activeRoute = _this.router.navigationModel().first(function (r) {
                    return r.isActive();
                });
                return activeRoute != null ? activeRoute.title : "";
            });
        }
        tasks.prototype.activate = function (args) {
            _super.prototype.activate.call(this, args);
        };

        tasks.prototype.routeIsVisible = function (route) {
            var systemOnlyPages = ["Restore Database", "Database Settings", "Replication", "SQL Replication"];
            if (jQuery.inArray(route.title, systemOnlyPages) !== -1) {
                return this.isOnSystemDatabase();
            } else {
                return true;
            }
        };
        return tasks;
    })(viewModelBase);

    
    return tasks;
});
